<?php

set_time_limit(0);

// --- convert: where the actual conversion takes place --- //



// --- insert_entry: Puts the function into the 1.0 db--- //
function insert_entry($entry) {
	global $db;
	
	if ($entry['code']=="") {
		$entry['code']=">";
	}
	
	if ( ($entry['category'] == "standard") || ($entry['category'] == "") || ($entry['category'][0]=="")) {
		$entry['category'] = array("default");
	}

	echo "<small>(".count($entry['comments'])." comments)</small> ";
	
	$entry = $db->set_entry($entry);
	if ($db->save_entry()) {
		echo "(inserted!)<br />";
		return TRUE;
	} else {
		echo "(<b>NOT</b> inserted!)<br />";
		return FALSE;
	}
	flush();


}

// -------
function start_conversion($file) {
	global $db, $content;
	
	// open the db, make sure it's updated..
	$db = new db();
	$db->generate_index();

	$fp = fopen($file, "rb"); 
	$content = "";

	if($fp){
		while(!feof($fp)) {
			$content = $content . fread($fp, 4096);
			if (strpos($content, "--------")>0) {
				parse_content();
			}
		} 
		$content .= "--------";
		parse_content();
	}

	echo "<br /><br />\n\n<b>conversion completed in ".timetaken()." seconds.</b><br /><br />\n";
	echo "<a href='index.php'>Log in to Pivot..</a>.</div>";

}



// Split the content into the entry and the rest that needs to pe parsed when more is read from the file.
function parse_content() {
	global $content;

	$parts = explode("--------", $content);

	for ($i=0 ; $i<(count($parts)-1); $i++) {
		parse_mtentry(trim($parts[$i]));
	}
	
	$content = $parts[ (count($parts)-1) ];

}


// This is where the actual parsing of the entry happens..
function parse_mtentry($content) {
	global $counter;

	list($head, $body) = explode("-----", $content);
	$content .= "-----";

	$entry = array();

	$entry['code']=">";
	$entry['date']="2004-01-01-01-01";

	if (preg_match("/AUTHOR:(.*)/i", $head, $match)) { 
		$entry['user']= str_replace(" ", "_", trim($match[1])); 

	}

	if (preg_match("/TITLE:(.*)/i", $head, $match)) { 
		$entry['title']= trim($match[1]); 
	}

	if (preg_match("/STATUS:(.*)/i", $head, $match)) { 
		$status= trim($match[1]); 
		if (strtolower($status)=="publish") {
			$entry['status'] = "publish";
		} else {
			$entry['status'] = "hold";
		}
	}

	if (preg_match("/ALLOW COMMENTS:(.*)/i", $head, $match)) { 
		$entry['allow_comments']= trim($match[1]); 
	}

	if (preg_match("/CONVERT BREAKS:(.*)/i", $head, $match)) { 
		$convert_lb= trim($match[1]); 
	
		// in pivot: 0 = nothing, 1 = linebreaks to br, 2 = textile
		if ( ($convert_lb=="textile_1") || ($convert_lb=="textile_2") || ($convert_lb=="textile") ) {
			$entry['convert_lb'] = 2;
		} else if ($convert_lb=="0") {
			$entry['convert_lb'] = 0;
		} else {
			// if either '1' or '__default__' or whatever, just set it to yes.
			$entry['convert_lb'] = 1;
		}
	}

	if (preg_match("/DATE:(.*)/i", $head, $match)) { 
		$entry['date']= fixdate($match[1]);
		$entry['publish_date']= fixdate($match[1]);
		$entry['edit_date']= fixdate($match[1]);
	}

	if (preg_match_all("/(PRIMARY )?CATEGORY:(.*)/i", $head, $match)) { 
		$entry['category'] = array_unique($match[2]);
		foreach($entry['category'] as $key => $val) {
			$entry['category'][$key]=trim($val);
		}
	}

	if (preg_match("/^BODY:(.*)-----/msiU", $content, $match)) { 
		$entry['introduction']= trim($match[1]); 
	}

	if (preg_match("/EXTENDED BODY:(.*)-----/msiU", $content, $match)) { 
		$entry['body']= trim($match[1]); 
	}

	// Parse all the comments..
	if (preg_match_all("/COMMENT:(.*)-----/msiU", $content, $match)) { 
		
		foreach($match[1] as $thismatch) {
			$thiscomment = array();
			if (preg_match("/AUTHOR:(.*)/i", $thismatch, $match)) { 
				$thiscomment['name']= $match[1]; 
				$thismatch = str_replace($match[0], "", $thismatch);
			}

			if (preg_match("/EMAIL:(.*)/i", $thismatch, $match)) { 
				$thiscomment['email']= $match[1]; 
				$thismatch = str_replace($match[0], "", $thismatch);
			}

			if (preg_match("/IP:(.*)/i", $thismatch, $match)) { 
				$thiscomment['ip']= $match[1]; 
				$thismatch = str_replace($match[0], "", $thismatch);
			}

			if (preg_match("/DATE:(.*)/i", $thismatch, $match)) { 
				$thiscomment['date']= fixdate($match[1]);
				$thismatch = str_replace($match[0], "", $thismatch);
			}

			if (preg_match("/URL:(.*)/i", $thismatch, $match)) { 
				$thiscomment['url']= $match[1]; 
				$thismatch = str_replace($match[0], "", $thismatch);
			}

			if (preg_match("/AUTHOR:(.*)/i", $thismatch, $match)) { 
				$thiscomment['name']= $match[1]; 
				$thismatch = str_replace($match[0], "", $thismatch);
			}
	
			$thiscomment['comment'] = trim($thismatch);
			$entry['comments'][] = $thiscomment;
		}	
	}


	//if we could parse something, insert it:
	if ( ($entry['body']!="") || ($entry['introduction']!="") || ($entry['user']!="") ) { 
		$counter++;
		echo $counter ." - ". $entry['title']." - \n";
		insert_entry($entry);
	}	
}

// small function to fix the date..
function fixdate($str) {
	return date("Y-m-d-H-i", strtotime(trim($str)));
}




function show_form() {
	global $HTTP_SERVER_VARS, $HTTP_POST_VARS;
	
	$self = $HTTP_SERVER_VARS['PHP_SELF'];
	$file = isset($HTTP_POST_VARS['file']) ? $HTTP_POST_VARS['file'] : "" ;
	
	echo "The current path is: ".dirname($self)."<br /><br />";
	
	echo "Please give the location of your exported file. <br />Depending on where you put it, this can look something like '../mt.txt' or  '../blogger_import.txt'.<br /><br />";
	echo "<b>Location:</b> <form method='post' action='$self'><input type='text' name='file' size='30' value='$file' /><br /><br />";
	
//	echo "<input type='checkbox' name='unlink' value='1' /> <b>Remove old entries after conversion?</b><br /><small>If you're server runs in safe_mode and you can't convert all entries in one go, use this option. This way the converted old entries will be removed. And you can restart the conversion to continue where it stopped.</small><br /><br />";
	
//	echo "<input type='checkbox' name='keepuid' value='1' /> <b>Keep original uid/numbers?</b><br /><small>If you choose to keep the original UID's, the original numbering of entries will remain the same. Otherwise the converted entries will be added to the new database and be assigned a new number (this is the prefered option).</small><br /><br />";
	
	
	
	echo "<input type='checkbox' name='confirm' value='1' /> <b>Yes, do it!</b> <br /><br />";
	echo "<input type='submit' value='Convert!' /></form>";
	
}


// -------- Main ----------

?>

<h1>Welcome to the quick-and-dirty MT import script</h1>
<p>Use this to import entries from the generic MT export format to Pivot.<br />See here for info on the format: <a href="http://www.movabletype.org/docs/mtimport.html">http://www.movabletype.org/docs/mtimport.html</a>.<br />You can also use this file to import from Blogger or other weblogtools, as long as the files are in this generic format.<br /><br /> </p>

<?php

if (count($HTTP_POST_VARS)>0) {
	
	// we know there's input..
	
	if (strlen($HTTP_POST_VARS['file'])<3) {
		
		// no file given
		echo "<b>You need to give the location of your exported file..</b><br /><br />";
		show_form();
		
	} else if (!file_exists(realpath($HTTP_POST_VARS['file']))) {
		
		// not a file..
		echo "<b>The filename you've given translates to: <br />";
		echo realpath($HTTP_POST_VARS['file'])."<br />";
		echo "This file does not exist.. Please verify your input.</b><br /><br />";
		show_form();
		
	} else if (!isset($HTTP_POST_VARS['confirm'])) {
		
		// not confirmed..
		echo "<b>You need to confirm that you want to start the conversion..</b><br /><br />";
		show_form();
		
	} else {
		
		// go!
		
		include_once("modules/old_module_xml.php");
		include_once("modules/old_xmlfile.php");
		include_once("pv_core.php");
		
		
		
		start_conversion($HTTP_POST_VARS['file']);
		
	}
	
	
	
} else {
	
	show_form();
	
}


?>

</BODY>
</HTML>
