<?php

set_time_limit(0);

// --- convert: reading file, parse it --- //
function convert($filename) {
	global $counter, $HTTP_POST_VARS;
	if ( (strpos($filename, "000") > 1) || (strpos($filename, ".cgi") > 1) ) {
		// name is something like '00000427.cgi', so go ahead
	
		$fp = fopen($filename,'r');
		
		$entry_info = fgets($fp,4096);  // entry info
		$entry_karma = fgets($fp,4096); // ips of karma voters (ignore)
		$entry_intro = fgets($fp,4096);  // intro
		$entry_body = fgets($fp,4096);  // body
		
		// decode information
		$entry_info = str_replace("|*|","\n",$entry_info);
		$entry_intro = str_replace("|*|","\n",$entry_intro);
		$entry_body = str_replace("|*|","\n",$entry_body);

		//echo "<br><br>ei=$entry_info\n";
		//echo "<br><br>eb=$entry_body\n";
		//echo "<br><br>em=$entry_more\n";

		list ($e_number, $e_author, $e_title, $e_wday, $e_mon, $e_mday, $e_year, $e_hour, $e_min, $e_sec, $e_ampm, $e_poskarma, $e_negkarma, $e_commentcount, $e_allowkarma, $e_allowcomments, $e_openclosed) = explode ("|", $entry_info);      
		

		if (($e_ampm == "PM") && ($e_hour != 12 ))
			$e_hour = $e_hour + 12;
				
		$row['date'] = date("Y-m-d-H-i", mktime($e_hour, $e_min, $e_sec, $e_mon, $e_mday, $e_year));
		
		// handle {{link, {{linkmo, {{email and {{emailmo
		$row['title'] = gm_parsecommands($e_title);
		$row['introduction'] = gm_parsecommands($entry_intro);
		$row['body'] = gm_parsecommands(trim($entry_body));


		$row['user']=strtolower($e_author);



		echo "Title: <b>".$row['title']."</b>";  
		
		// always the same..
		$row['code']=">";
		$row['subtitle']="";
		$row['comments']=Array();
		$row['category']=$category;

		while ($comment = fgets($fp,4096)) {

			$comment = str_replace("|*|","<br>\n",$comment);
			@list ($comm_name, $comm_ip, $comm_email, $comm_url, $dummy, $mon, $day, $year, $hour, $min, $dummy, $ampm, $comm_comment) = explode("|",$comment);      
			
			if ($ampm == "PM") 
				$hour = $hour + 12;
			$tempcomm['date'] = date("Y-m-d-H-i",mktime($hour, $min, 0, $mon, $day, $year));

			// add to comments
			//convert_addToComments($c_author, $c_userid, $c_body, $nucleus_itemid, 0, $c_timestamp, $c_ip);
			
			$tempcomm['name']=  $comm_name;
			$tempcomm['email']= $comm_email;
			$tempcomm['url']= $comm_url;
			$tempcomm['ip']= $comm_ip;
			$tempcomm['comment']= stripslashes(trim(gm_parsecommands($comm_comment)));
			$row['comments'][]=$tempcomm;

			echo ".";

		}

		fclose($fp);


		if (insert_entry($row)) {
			// Entry has been inserted, so we delete it..
			if (isset($HTTP_POST_VARS['unlink'])) {
				unlink($filename);
			}
			
		}

	}
	
}



function gm_parsecommands($text) {
    // special markup characters
    //  **bold text** -> <b>bold text</b>
    //  __underlined text__ -> <u>underlined text</u>
    //  \\italic text\\ -> <i>italic text</i>
    $to_replace = array(
        "/\*\*(.*?)\*\*/is",
        "/\\\\(.*?)\\\\/is",
        "/__(.*?)__/is",
		"/{{popup ([a-zA-Z0-9.]*)\s(.*)}}/Uis" // {{popup IM000030.jpg IM000030 800x600}}
    );
    $replace_by = array(
        "<b>\\1</b>",
        "<i>\\1</i>",
        "<u>\\1</u>",
		"[[popup:\\1:\\2:center:1]]" // [[popup:errrr.jpg:pom::center:1]]
    );
    $text = preg_replace($to_replace, $replace_by, $text);  

    if (strstr($text,"{{link") || stristr($text,"{{email") || stristr($text,"{{popup")) {
        $to_replace = array(
            "/({{linkmo) (http|https|ftp)(:\/\/\S+?) (.+?)(\|)(.+?)(}})/ies",
            "/({{link) (http|https|ftp)(:\/\/\S+?)(}})/is",
            "/({{link) (http|https|ftp)(:\/\/\S+?) (.+?)(}})/is",
            "/({{emailmo) (\S+\@\S+?) (.+?)(\|)(.+?)(}})/ies",
            "/({{email) (\S+\@\S+?)(}})/is",
            "/({{email) (\S+\@\S+?) (.+?)(}})/is",
        );
        $replace_by = array(
            // linkmo
            'gm_linkmo("\\2\\3","\\6","\\4")',
            // link
            "<a href='\\2\\3'>\\2\\3</a>",
            "<a href='\\2\\3'>\\4</a>",
            // emailmo
            'gm_linkmo("mailto:\\2","\\5","\\3")',
            // email
            "<a href='mailto:\\2'>\\2</a>",
            "<a href='mailto:\\2'>\\3</a>",
            // popup
        );
        $text = preg_replace($to_replace, $replace_by, $text);
    }


    return $text;
}

// makes sure quotes are escaped in javascript strings
// php seems to quote the arguments as the get passed to this method by preg_replace 
// with /e modifier
function gm_linkmo($url, $mouseover, $text) {

    // remove slashes from text (not needed there)
    $text = stripslashes($text);    
    
    // replace " by \' in mouseover (to avoid error)
    $mouseover = str_replace('"',"\'",$mouseover);

    return '<a href="' . $url . '" onmouseover="window.status=\'' . $mouseover .  '\';return true" onmouseout="window.status=\'\';return true">'.$text.'</a>';
}





// --- insert_entry: Puts the function into the 1.0 db--- //
function insert_entry($entry) {
	global $db;
	
	if ($entry['code']=="") {
		$entry['code']=">";
	}
	
	if ( ($entry['category'] == "standard") || ($entry['category'] == "") ) {
		$entry['category'] = "default";
	}
	$entry['category'] = array($entry['category']);
	
	
	
	$entry = $db->set_entry($entry);
	if ($db->save_entry()) {
		echo "(inserted!)<br />";
		return TRUE;
	} else {
		echo "(<b>NOT</b> inserted!)<br />";
		return FALSE;
	}

	flush();
	
	
}

// -------
function start_conversion($dir) {
	global $db;
	
	// open the db, make sure it's updated..
	$db = new db();
	$db->generate_index();
	
	$dir= realpath($dir);
	
	$d= dir($dir);
	
	while ($filename=$d->read()) {
		
		if ( ($filename=="..") || ($filename==".") ) { continue; }
		
		convert($dir."/".$filename);
					
		flush();
		
	}
	
	$d->close();
	
	echo "<br /><br />\n\n<b>conversion completed in ".timetaken()." seconds.</b><br /><br />\n";
	echo "<a href='index.php'>Log in to Pivot..</a>.</div>";
	
}


function show_form() {
	global $HTTP_SERVER_VARS, $HTTP_POST_VARS;
	
	$self = $HTTP_SERVER_VARS['PHP_SELF'];
	$dir = isset($HTTP_POST_VARS['dir']) ? $HTTP_POST_VARS['dir'] : "" ;
	
	echo "The current path is: ".dirname($self)."<br /><br />";
	
	echo "Please give the location of your old greymatter's data folder. This is the folder with all the files that are named 00000001.cgi, 00000002.cgi, etcetera. <br />Depending on where your previous install is located, this can look something like '../greymatter/archive/'.<br /><br />";
	echo "<b>Location:</b> <form method='post' action='$self'><input type='text' name='dir' size='30' value='$dir' /><br /><br />";
	
	echo "<input type='checkbox' name='unlink' value='1' /> <b>Remove old entries after conversion?</b><br /><small>If your server runs in safe_mode and you can't convert all entries in one go, use this option. This way the converted old entries will be removed. And you can restart the conversion to continue where it stopped.</small><br /><br />";
	
	
	echo "<input type='checkbox' name='confirm' value='1' /> <b>Yes, do it!</b> <br /><br />";
	echo "<input type='submit' value='Convert!' /></form>";
	
}


// -------- Main ----------

?>

<h1>Welcome to the quick-and-dirty conversion script</h1>
<h3>Use this tool to convert entries from Greymatter to Pivot.</h3>

<?php

if (count($HTTP_POST_VARS)>0) {
	
	// we know there's input..
	
	if (strlen($HTTP_POST_VARS['dir'])<3) {
		
		// no dir given
		echo "<b>You need to give the location of your old Pivot's db/ folder..</b><br /><br />";
		show_form();
		
	} else if (!is_dir(realpath($HTTP_POST_VARS['dir']))) {
		
		// not a dir..
		echo "<b>The dir you've given translates to: <br />";
		echo realpath($HTTP_POST_VARS['dir'])."<br />";
		echo "This folder does not exist.. Please verify your input.</b><br /><br />";
		show_form();
		
	} else if (!isset($HTTP_POST_VARS['confirm'])) {
		
		// not confirmed..
		echo "<b>You need to confirm that you want to start the conversion..</b><br /><br />";
		show_form();
		
	} else {
		
		// go!
		
		include_once("modules/old_module_xml.php");
		include_once("modules/old_xmlfile.php");
		include_once("pv_core.php");
		
		
		
		start_conversion($HTTP_POST_VARS['dir']);
		
	}
	
	
	
} else {
	
	show_form();
	
}


?>

</BODY>
</HTML>
